/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#pragma once

#include "OE_stitchs.h"

namespace Pakal { class Archive; }

class OE_linkstitch : public OE_stitchs
{
	public:
		//OE_linkstitch();
		OE_linkstitch(OE_stitchs* stitchStart=nullptr, OE_stitchs* stitchEnd=nullptr);
		~OE_linkstitch();

		virtual void persist(Pakal::Archive* archive) override;

		virtual bool check();

		//virtual void refresh();

		virtual void refresh(float dpi, bool force = false);

		void setStitchStart( OE_stitchs* stitch);
		void setStitchEnd( OE_stitchs* stitch);
		OE_stitchs* getStitchStart();
		OE_stitchs* getStitchEnd();
		vector_2d getStepPt( int pos);

		void setStepPts( std::list<vector_2d> pts);
		void setStepPt( int pos, vector_2d pt);
		void addStepPt( int pos, vector_2d pt);
		void delStepPt( int pos);

		std::list<vector_2d> stepPts;

		void delDependency(OE_base * object);
		virtual void refreshDependency();

		static float defaultLinkMaxlen;

		virtual void move(vector_2d offset);
		virtual void scale(vector_2d ratio, vector_2d pos);

	protected:
		OE_stitchs* stitchStart;
		OE_stitchs* stitchEnd;
};

